/* ***********************************************************
 * This file was automatically generated on 2024-04-08.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.32                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures distance up to 150cm with infrared light
	/// </summary>
	public class BrickletDistanceIR : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 25;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Distance IR Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DISTANCE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_SAMPLING_POINT = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SAMPLING_POINT = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DISTANCE_CALLBACK_PERIOD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DISTANCE_CALLBACK_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 13;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 14;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_DISTANCE = 15;

		private const int CALLBACK_ANALOG_VALUE = 16;

		private const int CALLBACK_DISTANCE_REACHED = 17;

		private const int CALLBACK_ANALOG_VALUE_REACHED = 18;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackPeriod"/>. The parameter is the distance of the
		///  sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletDistanceIR.DistanceCallback"/> callback is only triggered if the distance has changed since the
		///  last triggering.
		/// </summary>
		public event DistanceEventHandler DistanceCallback;
		/// <summary>
		/// </summary>
		public delegate void DistanceEventHandler(BrickletDistanceIR sender, int distance);

		/// <summary>
		/// </summary>
		public event DistanceEventHandler Distance // for backward compatibility
		{
			add { DistanceCallback += value; }
			remove { DistanceCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackPeriod"/>. The parameter is the analog value of the
		///  sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletDistanceIR.AnalogValueCallback"/> callback is only triggered if the analog value has changed
		///  since the last triggering.
		/// </summary>
		public event AnalogValueEventHandler AnalogValueCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueEventHandler(BrickletDistanceIR sender, int value);

		/// <summary>
		/// </summary>
		public event AnalogValueEventHandler AnalogValue // for backward compatibility
		{
			add { AnalogValueCallback += value; }
			remove { AnalogValueCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackThreshold"/> is reached.
		///  The parameter is the distance of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDebouncePeriod"/>.
		/// </summary>
		public event DistanceReachedEventHandler DistanceReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void DistanceReachedEventHandler(BrickletDistanceIR sender, int distance);

		/// <summary>
		/// </summary>
		public event DistanceReachedEventHandler DistanceReached // for backward compatibility
		{
			add { DistanceReachedCallback += value; }
			remove { DistanceReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackThreshold"/> is reached.
		///  The parameter is the analog value of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDebouncePeriod"/>.
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void AnalogValueReachedEventHandler(BrickletDistanceIR sender, int value);

		/// <summary>
		/// </summary>
		public event AnalogValueReachedEventHandler AnalogValueReached // for backward compatibility
		{
			add { AnalogValueReachedCallback += value; }
			remove { AnalogValueReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletDistanceIR(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_DISTANCE] = new CallbackWrapper(OnDistanceCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE] = new CallbackWrapper(OnAnalogValueCallback);
			callbackWrappers[CALLBACK_DISTANCE_REACHED] = new CallbackWrapper(OnDistanceReachedCallback);
			callbackWrappers[CALLBACK_ANALOG_VALUE_REACHED] = new CallbackWrapper(OnAnalogValueReachedCallback);


			responseExpected[FUNCTION_GET_DISTANCE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SAMPLING_POINT] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SAMPLING_POINT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DISTANCE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DISTANCE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the distance measured by the sensor. Possible
		///  distance ranges are 40 to 300, 100 to 800 and 200 to 1500, depending on the
		///  selected IR sensor.
		///  
		///  If you want to get the distance periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletDistanceIR.DistanceCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackPeriod"/>.
		/// </summary>
		public int GetDistance()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DISTANCE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Returns the value as read by a 12-bit analog-to-digital converter.
		///  
		///  <note>
		///   The value returned by <see cref="Tinkerforge.BrickletDistanceIR.GetDistance"/> is averaged over several samples
		///   to yield less noise, while <see cref="Tinkerforge.BrickletDistanceIR.GetAnalogValue"/> gives back raw
		///   unfiltered analog values. The only reason to use <see cref="Tinkerforge.BrickletDistanceIR.GetAnalogValue"/> is,
		///   if you need the full resolution of the analog-to-digital converter.
		///  </note>
		///  
		///  If you want the analog value periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletDistanceIR.AnalogValueCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public int GetAnalogValue()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets a sampling point value to a specific position of the lookup table.
		///  The lookup table comprises 128 equidistant analog values with
		///  corresponding distances.
		///  
		///  If you measure a distance of 50cm at the analog value 2048, you
		///  should call this function with (64, 5000). The utilized analog-to-digital
		///  converter has a resolution of 12 bit. With 128 sampling points on the
		///  whole range, this means that every sampling point has a size of 32
		///  analog values. Thus the analog value 2048 has the corresponding sampling
		///  point 64 = 2048/32.
		///  
		///  Sampling points are saved on the EEPROM of the Distance IR Bricklet and
		///  loaded again on startup.
		///  
		///  <note>
		///   An easy way to calibrate the sampling points of the Distance IR Bricklet is
		///   implemented in the Brick Viewer. If you want to calibrate your Bricklet it is
		///   highly recommended to use this implementation.
		///  </note>
		/// </summary>
		public void SetSamplingPoint(byte position, int distance)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(11, FUNCTION_SET_SAMPLING_POINT);
			LEConverter.To((byte)position, 8, request);
			LEConverter.To((short)distance, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the distance to a sampling point position as set by
		///  <see cref="Tinkerforge.BrickletDistanceIR.SetSamplingPoint"/>.
		/// </summary>
		public int GetSamplingPoint(byte position)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_SAMPLING_POINT);
			LEConverter.To((byte)position, 8, request);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletDistanceIR.DistanceCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletDistanceIR.DistanceCallback"/> callback is only triggered if the distance has changed since the
		///  last triggering.
		/// </summary>
		public void SetDistanceCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DISTANCE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackPeriod"/>.
		/// </summary>
		public long GetDistanceCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DISTANCE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletDistanceIR.AnalogValueCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletDistanceIR.AnalogValueCallback"/> callback is only triggered if the analog value has
		///  changed since the last triggering.
		/// </summary>
		public void SetAnalogValueCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackPeriod"/>.
		/// </summary>
		public long GetAnalogValueCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletDistanceIR.DistanceReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the distance is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the distance is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the distance is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the distance is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetDistanceCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackThreshold"/>.
		/// </summary>
		public void GetDistanceCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletDistanceIR.AnalogValueReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the analog value is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the analog value is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the analog value is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the analog value is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetAnalogValueCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackThreshold"/>.
		/// </summary>
		public void GetAnalogValueCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletDistanceIR.DistanceReachedCallback"/>,
		///  * <see cref="Tinkerforge.BrickletDistanceIR.AnalogValueReachedCallback"/>
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletDistanceIR.SetDistanceCallbackThreshold"/>,
		///  * <see cref="Tinkerforge.BrickletDistanceIR.SetAnalogValueCallbackThreshold"/>
		///  
		///  keep being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletDistanceIR.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnDistanceCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int distance = LEConverter.UShortFrom(8, response);
			var handler = DistanceCallback;

			if (handler != null)
			{
				handler(this, distance);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int value = LEConverter.UShortFrom(8, response);
			var handler = AnalogValueCallback;

			if (handler != null)
			{
				handler(this, value);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnDistanceReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int distance = LEConverter.UShortFrom(8, response);
			var handler = DistanceReachedCallback;

			if (handler != null)
			{
				handler(this, distance);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAnalogValueReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int value = LEConverter.UShortFrom(8, response);
			var handler = AnalogValueReachedCallback;

			if (handler != null)
			{
				handler(this, value);
			}
		}
	}
}
