/* ***********************************************************
 * This file was automatically generated on 2024-04-08.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.32                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  16-channel digital input/output
	/// </summary>
	public class BrickletIO16 : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 28;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "IO-16 Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_PORT = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_PORT = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_PORT_CONFIGURATION = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_PORT_CONFIGURATION = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_PORT_INTERRUPT = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_PORT_INTERRUPT = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_PORT_MONOFLOP = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_PORT_MONOFLOP = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_SELECTED_VALUES = 13;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_EDGE_COUNT = 14;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_EDGE_COUNT_CONFIG = 15;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_EDGE_COUNT_CONFIG = 16;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_INTERRUPT = 9;

		private const int CALLBACK_MONOFLOP_DONE = 12;


		/// <summary>
		/// </summary>
		public const char DIRECTION_IN = 'i';

		/// <summary>
		/// </summary>
		public const char DIRECTION_OUT = 'o';

		/// <summary>
		/// </summary>
		public const byte EDGE_TYPE_RISING = 0;

		/// <summary>
		/// </summary>
		public const byte EDGE_TYPE_FALLING = 1;

		/// <summary>
		/// </summary>
		public const byte EDGE_TYPE_BOTH = 2;


		/// <summary>
		///  This callback is triggered whenever a change of the voltage level is detected
		///  on pins where the interrupt was activated with <see cref="Tinkerforge.BrickletIO16.SetPortInterrupt"/>.
		///  
		///  The values are the port, a bitmask that specifies which interrupts occurred
		///  and the current value bitmask of the port.
		///  
		///  For example:
		///  
		///  * ('a', 1, 1) or ('a', 0b00000001, 0b00000001) means that on port A an
		///    interrupt on pin 0 occurred and currently pin 0 is high and pins 1-7 are low.
		///  * ('b', 129, 254) or ('b', 0b10000001, 0b11111110) means that on port B
		///    interrupts on pins 0 and 7 occurred and currently pin 0 is low and pins 1-7
		///    are high.
		/// </summary>
		public event InterruptEventHandler InterruptCallback;
		/// <summary>
		/// </summary>
		public delegate void InterruptEventHandler(BrickletIO16 sender, char port, byte interruptMask, byte valueMask);

		/// <summary>
		/// </summary>
		public event InterruptEventHandler Interrupt // for backward compatibility
		{
			add { InterruptCallback += value; }
			remove { InterruptCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered whenever a monoflop timer reaches 0. The
		///  parameters contain the port, the involved pins and the current value of
		///  the pins (the value after the monoflop).
		/// </summary>
		public event MonoflopDoneEventHandler MonoflopDoneCallback;
		/// <summary>
		/// </summary>
		public delegate void MonoflopDoneEventHandler(BrickletIO16 sender, char port, byte selectionMask, byte valueMask);

		/// <summary>
		/// </summary>
		public event MonoflopDoneEventHandler MonoflopDone // for backward compatibility
		{
			add { MonoflopDoneCallback += value; }
			remove { MonoflopDoneCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletIO16(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_INTERRUPT] = new CallbackWrapper(OnInterruptCallback);
			callbackWrappers[CALLBACK_MONOFLOP_DONE] = new CallbackWrapper(OnMonoflopDoneCallback);


			responseExpected[FUNCTION_SET_PORT] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_PORT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_PORT_CONFIGURATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_PORT_CONFIGURATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_PORT_INTERRUPT] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_PORT_INTERRUPT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_PORT_MONOFLOP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_PORT_MONOFLOP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SELECTED_VALUES] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_EDGE_COUNT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_EDGE_COUNT_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_EDGE_COUNT_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Sets the output value (high or low) for a port ("a" or "b") with a bitmask
		///  (8bit). A 1 in the bitmask means high and a 0 in the bitmask means low.
		///  
		///  For example: The value 15 or 0b00001111 will turn the pins 0-3 high and the
		///  pins 4-7 low for the specified port.
		///  
		///  All running monoflop timers of the given port will be aborted if this function
		///  is called.
		///  
		///  <note>
		///   This function does nothing for pins that are configured as input.
		///   Pull-up resistors can be switched on with <see cref="Tinkerforge.BrickletIO16.SetPortConfiguration"/>.
		///  </note>
		/// </summary>
		public void SetPort(char port, byte valueMask)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_PORT);
			LEConverter.To((char)port, 8, request);
			LEConverter.To((byte)valueMask, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns a bitmask of the values that are currently measured on the
		///  specified port. This function works if the pin is configured to input
		///  as well as if it is configured to output.
		/// </summary>
		public byte GetPort(char port)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_PORT);
			LEConverter.To((char)port, 8, request);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Configures the value and direction of a specified port. Possible directions
		///  are 'i' and 'o' for input and output.
		///  
		///  If the direction is configured as output, the value is either high or low
		///  (set as *true* or *false*).
		///  
		///  If the direction is configured as input, the value is either pull-up or
		///  default (set as *true* or *false*).
		///  
		///  For example:
		///  
		///  * ('a', 255, 'i', true) or ('a', 0b11111111, 'i', true) will set all pins of port A as input pull-up.
		///  * ('a', 128, 'i', false) or ('a', 0b10000000, 'i', false) will set pin 7 of port A as input default (floating if nothing is connected).
		///  * ('b', 3, 'o', false) or ('b', 0b00000011, 'o', false) will set pins 0 and 1 of port B as output low.
		///  * ('b', 4, 'o', true) or ('b', 0b00000100, 'o', true) will set pin 2 of port B as output high.
		///  
		///  Running monoflop timers for the selected pins will be aborted if this
		///  function is called.
		/// </summary>
		public void SetPortConfiguration(char port, byte selectionMask, char direction, bool value)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_PORT_CONFIGURATION);
			LEConverter.To((char)port, 8, request);
			LEConverter.To((byte)selectionMask, 9, request);
			LEConverter.To((char)direction, 10, request);
			LEConverter.To((bool)value, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns a direction bitmask and a value bitmask for the specified port. A 1 in
		///  the direction bitmask means input and a 0 in the bitmask means output.
		///  
		///  For example: A return value of (15, 51) or (0b00001111, 0b00110011) for
		///  direction and value means that:
		///  
		///  * pins 0 and 1 are configured as input pull-up,
		///  * pins 2 and 3 are configured as input default,
		///  * pins 4 and 5 are configured as output high
		///  * and pins 6 and 7 are configured as output low.
		/// </summary>
		public void GetPortConfiguration(char port, out byte directionMask, out byte valueMask)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_PORT_CONFIGURATION);
			LEConverter.To((char)port, 8, request);

			byte[] response = SendRequest(request, 10);

			directionMask = LEConverter.ByteFrom(8, response);
			valueMask = LEConverter.ByteFrom(9, response);
		}

		/// <summary>
		///  Sets the debounce period of the <see cref="Tinkerforge.BrickletIO16.InterruptCallback"/> callback.
		///  
		///  For example: If you set this value to 100, you will get the interrupt
		///  maximal every 100ms. This is necessary if something that bounces is
		///  connected to the IO-16 Bricklet, such as a button.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletIO16.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the pins on which an interrupt is activated with a bitmask.
		///  Interrupts are triggered on changes of the voltage level of the pin,
		///  i.e. changes from high to low and low to high.
		///  
		///  For example: ('a', 129) or ('a', 0b10000001) will enable the interrupt for
		///  pins 0 and 7 of port a.
		///  
		///  The interrupt is delivered with the <see cref="Tinkerforge.BrickletIO16.InterruptCallback"/> callback.
		/// </summary>
		public void SetPortInterrupt(char port, byte interruptMask)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_PORT_INTERRUPT);
			LEConverter.To((char)port, 8, request);
			LEConverter.To((byte)interruptMask, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the interrupt bitmask for the specified port as set by
		///  <see cref="Tinkerforge.BrickletIO16.SetPortInterrupt"/>.
		/// </summary>
		public byte GetPortInterrupt(char port)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_PORT_INTERRUPT);
			LEConverter.To((char)port, 8, request);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Configures a monoflop of the pins specified by the second parameter as 8 bit
		///  long bitmask. The specified pins must be configured for output. Non-output
		///  pins will be ignored.
		///  
		///  The third parameter is a bitmask with the desired value of the specified
		///  output pins. A 1 in the bitmask means high and a 0 in the bitmask means low.
		///  
		///  The forth parameter indicates the time that the pins should hold
		///  the value.
		///  
		///  If this function is called with the parameters ('a', 9, 1, 1500) or
		///  ('a', 0b00001001, 0b00000001, 1500): Pin 0 will get high and pin 3 will get
		///  low on port 'a'. In 1.5s pin 0 will get low and pin 3 will get high again.
		///  
		///  A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
		///  have a RS485 bus and an IO-16 Bricklet connected to one of the slave
		///  stacks. You can now call this function every second, with a time parameter
		///  of two seconds and pin 0 set to high. Pin 0 will be high all the time. If now
		///  the RS485 connection is lost, then pin 0 will get low in at most two seconds.
		/// </summary>
		public void SetPortMonoflop(char port, byte selectionMask, byte valueMask, long time)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(15, FUNCTION_SET_PORT_MONOFLOP);
			LEConverter.To((char)port, 8, request);
			LEConverter.To((byte)selectionMask, 9, request);
			LEConverter.To((byte)valueMask, 10, request);
			LEConverter.To((int)time, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns (for the given pin) the current value and the time as set by
		///  <see cref="Tinkerforge.BrickletIO16.SetPortMonoflop"/> as well as the remaining time until the value flips.
		///  
		///  If the timer is not running currently, the remaining time will be returned
		///  as 0.
		/// </summary>
		public void GetPortMonoflop(char port, byte pin, out byte value, out long time, out long timeRemaining)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_GET_PORT_MONOFLOP);
			LEConverter.To((char)port, 8, request);
			LEConverter.To((byte)pin, 9, request);

			byte[] response = SendRequest(request, 17);

			value = LEConverter.ByteFrom(8, response);
			time = LEConverter.UIntFrom(9, response);
			timeRemaining = LEConverter.UIntFrom(13, response);
		}

		/// <summary>
		///  Sets the output value (high or low) for a port ("a" or "b" with a bitmask,
		///  according to the selection mask. The bitmask is 8 bit long and a 1 in the
		///  bitmask means high and a 0 in the bitmask means low.
		///  
		///  For example: The parameters ('a', 192, 128) or ('a', 0b11000000, 0b10000000)
		///  will turn pin 7 high and pin 6 low on port A, pins 0-6 will remain untouched.
		///  
		///  Running monoflop timers for the selected pins will be aborted if this
		///  function is called.
		///  
		///  <note>
		///   This function does nothing for pins that are configured as input.
		///   Pull-up resistors can be switched on with <see cref="Tinkerforge.BrickletIO16.SetPortConfiguration"/>.
		///  </note>
		/// </summary>
		public void SetSelectedValues(char port, byte selectionMask, byte valueMask)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(11, FUNCTION_SET_SELECTED_VALUES);
			LEConverter.To((char)port, 8, request);
			LEConverter.To((byte)selectionMask, 9, request);
			LEConverter.To((byte)valueMask, 10, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the current value of the edge counter for the selected pin on port A.
		///  You can configure the edges that are counted with <see cref="Tinkerforge.BrickletIO16.SetEdgeCountConfig"/>.
		///  
		///  If you set the reset counter to *true*, the count is set back to 0
		///  directly after it is read.
		///  
		///  .. versionadded:: 2.0.3$nbsp;(Plugin)
		/// </summary>
		public long GetEdgeCount(byte pin, bool resetCounter)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_GET_EDGE_COUNT);
			LEConverter.To((byte)pin, 8, request);
			LEConverter.To((bool)resetCounter, 9, request);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Configures the edge counter for the selected pin of port A. Pins 0 and 1
		///  are available for edge counting.
		///  
		///  The edge type parameter configures if rising edges, falling edges or
		///  both are counted if the pin is configured for input. Possible edge types are:
		///  
		///  * 0 = rising
		///  * 1 = falling
		///  * 2 = both
		///  
		///  Configuring an edge counter resets its value to 0.
		///  
		///  If you don't know what any of this means, just leave it at default. The
		///  default configuration is very likely OK for you.
		///  
		///  .. versionadded:: 2.0.3$nbsp;(Plugin)
		/// </summary>
		public void SetEdgeCountConfig(byte pin, byte edgeType, byte debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(11, FUNCTION_SET_EDGE_COUNT_CONFIG);
			LEConverter.To((byte)pin, 8, request);
			LEConverter.To((byte)edgeType, 9, request);
			LEConverter.To((byte)debounce, 10, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the edge type and debounce time for the selected pin of port A as set by
		///  <see cref="Tinkerforge.BrickletIO16.SetEdgeCountConfig"/>.
		///  
		///  .. versionadded:: 2.0.3$nbsp;(Plugin)
		/// </summary>
		public void GetEdgeCountConfig(byte pin, out byte edgeType, out byte debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_EDGE_COUNT_CONFIG);
			LEConverter.To((byte)pin, 8, request);

			byte[] response = SendRequest(request, 10);

			edgeType = LEConverter.ByteFrom(8, response);
			debounce = LEConverter.ByteFrom(9, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnInterruptCallback(byte[] response)
		{
			if (response.Length != 11)
			{
				return; // silently ignoring callback with wrong length
			}

			char port = LEConverter.CharFrom(8, response);
			byte interruptMask = LEConverter.ByteFrom(9, response);
			byte valueMask = LEConverter.ByteFrom(10, response);
			var handler = InterruptCallback;

			if (handler != null)
			{
				handler(this, port, interruptMask, valueMask);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnMonoflopDoneCallback(byte[] response)
		{
			if (response.Length != 11)
			{
				return; // silently ignoring callback with wrong length
			}

			char port = LEConverter.CharFrom(8, response);
			byte selectionMask = LEConverter.ByteFrom(9, response);
			byte valueMask = LEConverter.ByteFrom(10, response);
			var handler = MonoflopDoneCallback;

			if (handler != null)
			{
				handler(this, port, selectionMask, valueMask);
			}
		}
	}
}
